program singlecyclepathgraphs;
uses sysutils,math;
const maxn = 100;
const minNode = 1;
const batch = 5000;

var n: integer;
    cycle: array[1..maxn] of integer;
    used: array[minNode..minNode+ 2*maxn] of boolean;
    maxNode, i: integer;
    outputFormat: (ofCycleJSON, ofEdgesJSON, ofEdgesJSONWrapped, ofEdgesJSONBatched);//printCycle: boolean;
    outputCount: integer;
procedure enum(i: integer);
var
  j, previous, blockStart, previousBlockLength: Integer;
begin
  if i > n then begin
    if cycle[2] > cycle[n] then
      exit; //FILTER ordering (cycle a-b-c and c-b-a are identical)
    previous := minNode;
    blockStart := minNode;
    previousBlockLength := n;
    for j := minNode + 1 to maxNode do
      if used[j] then begin
        case j - previous of
         0:assert(false);
         1: ;
         2: if (previous - blockStart > previousBlockLength ) {and false} then exit //FILTER block permutations
            else begin
              previousBlockLength := previous - blockStart;
              blockStart:=j;
            end
         else {>2} exit; //FILTER too large delta (compression lemma)
        end;
        previous := j;
      end;
    if (previous - blockStart > previousBlockLength ) {and false} then exit; //FILTER block permutations
    if outputFormat = ofCycleJSON then begin
      write('[', cycle[1]);
      for j := 2 to n do
        write( ', ', cycle[j]);
      writeln(']');
    end else begin
      if (outputFormat in [ofEdgesJSONWrapped, ofEdgesJSONBatched]) and (outputCount > 0) then write(', ');
      inc(outputCount);
      write('[[', min(cycle[1], cycle[2]), ', ', max(cycle[1], cycle[2]), ']');
      for j := 2 to n do
        write( ', [', min(cycle[j],cycle[j+1]), ', ',max(cycle[j],cycle[j+1]),']');
      write(']');
      if outputFormat <> ofEdgesJSONBatched then writeln
      else begin
        if outputCount >= batch then begin
          writeln(']');
          write('[');
          outputCount := 0;
        end;
      end;
    end;
    exit;

  end;
  for j := minNode to maxNode do begin
    if used[j] then continue;
    cycle[i] := j;
    used[j] := true;
    enum(i + 1);
    used[j] := false;
  end
end;

begin
  outputFormat:=ofEdgesJSONWrapped;
  for i := 1 to ParamCount do begin
    n := StrToIntDef(paramstr(i), n);
    case paramstr(i) of
    '--print-cycle-json': outputFormat:=ofCycleJSON;
    '--print-edges-json': outputFormat:=ofEdgesJSON;
    '--print-edges-wrapped-json': outputFormat:=ofEdgesJSONWrapped;
    '--print-edges-batched-json': outputFormat:=ofEdgesJSONBatched;
    end;
  end;

  if outputFormat = ofEdgesJSONWrapped then writeln('[')
  else if outputFormat = ofEdgesJSONBatched then write('[');


  assert(n >= 3);
  maxNode := minNode + 2 * n;
  cycle[1] := minNode;
  cycle[n+1] := minNode;
  used[minNode] := true; //FILTER shifted

  writeln(stderr, 'cycle length: ', n, ' max nodes: ', maxNode - minNode,  ' format: ', outputFormat);
  if outputFormat = ofEdgesJSONBatched then writeln(stderr, 'batch size: ', batch);

  enum(1 + 1);

  if outputFormat in [ofEdgesJSONWrapped, ofEdgesJSONBatched] then writeln(']');

end.



